<template>
  <div class="bg-container">
    <div class="container">
      <div id="viewer"></div>
    </div>
  </div>
</template>

<script>
import { baseUrl, tidoConfig } from '../utilities/tido-config';
import { mounted_and_updated, toggle_color_mode_button } from '../mounted_and_updated';

export default {
  async mounted() {
    
    if (baseUrl == "") return;

    const collection = `${baseUrl}/api/eupt/collection.json`;

    window.tido = new window.Tido({
      ...tidoConfig,
      collection
    });

    // Dark Mode
    //
    // get the buttons that change dark mode on page/tido level
    var btn_page = document.querySelector(".toggle-color-mode-button");
    var btn_tido = document.querySelector(".tido").querySelector(".header").querySelector("button");
    //
    // is dark mode activated on page/tido level?
    var dark_page = document.querySelector("html").classList.contains("dark");
    var dark_tido = (document.getElementById("app").getAttribute("color-scheme") == "dark");
    //
    // if dark mode is activated only at page/tido level,
    // change the mode at tido level
    if(dark_page != dark_tido){
        btn_tido.click();
    }
    //
    // whenever dark mode is changed at the page level,
    // change it also on tido level
    btn_page.addEventListener("click", function(){ btn_tido.click() });
    //
    // hide the button on tido level
    btn_tido.style.visibility = "hidden";

    // Synchronous Scrolling
    //
    // When the user scrolls in one of the panels,
    // the other panel should scroll accordingly.
    var panels = [];
    while(panels.length == 0){
      await new Promise(r => setTimeout(r, 250));
      panels = Array.from(document.getElementsByClassName("content-view"));
    }
    //
    var referencePanel = null;
    var lastScrollTime = 0;
    //
    function getPanelPositions(){
      var panelPositionsById = [];      // panel index => (line id => scroll offset)
      var panelPositionsByOffset = [];  // panel index => (scroll offset => line id)
      panels.forEach((panel) => {
        const lines = Array.from(panel.querySelectorAll(".part,.unit"));
        const positionsById = {};
        const positionsByOffset = {};
        lines.forEach((line) => {
          var offset = line.offsetTop;
          if(line.classList.contains("part")){
            var id = line.id;
            if(id.startsWith("line_")){
              positionsById[id] = offset;
              positionsByOffset[offset] = id;
            }
          }
          else if(line.classList.contains("unit")){
            var ids = line.getAttribute("data-corresp").split(" ");
            ids.forEach((id) => {
              if(id.startsWith("line_")){
                positionsById[id] = offset;
                positionsByOffset[offset] = id;
              }
            });
          }
        });
        panelPositionsById.push(positionsById);
        panelPositionsByOffset.push(positionsByOffset);
      });
      return [panelPositionsById, panelPositionsByOffset];
    }
    //
    function getScrollPosition(scrolledPanel, targetPanel, mode = null){
      if(mode == "line"){
        var panelPositions = getPanelPositions();
        var panelPositionsById = panelPositions[0];
        var panelPositionsByOffset = panelPositions[1];
        var scrolledPanelIndex = panels.indexOf(scrolledPanel);
        var targetPanelIndex = panels.indexOf(targetPanel);
        var scrollOffset = scrolledPanel.scrollTop;
        var scrollStartOffset = scrollOffset;
        var startId = null;
        while(scrollStartOffset > 0){
          if(panelPositionsByOffset[scrolledPanelIndex].hasOwnProperty(scrollStartOffset.toString())){
            startId = panelPositionsByOffset[scrolledPanelIndex][scrollStartOffset.toString()];
            break;
          }
          scrollStartOffset -= 1;
        }
        var scrollEndOffset = scrollOffset;
        var endId = null;
        while(scrollEndOffset < panels[scrolledPanelIndex].scrollHeight){
          if(panelPositionsByOffset[scrolledPanelIndex].hasOwnProperty(scrollEndOffset.toString())){
            endId = panelPositionsByOffset[scrolledPanelIndex][scrollEndOffset.toString()];
            break;
          }
          scrollEndOffset += 1;
        }
        var targetStartOffset = (scrollStartOffset == 0 ? 0 : panelPositionsById[targetPanelIndex][startId]);
        var targetEndOffset = (scrollEndOffset == panels[scrolledPanelIndex].scrollHeight ? panels[targetPanelIndex].scrollHeight : panelPositionsById[targetPanelIndex][endId]);
        var targetOffset = targetStartOffset + (scrollEndOffset == scrollStartOffset ? 0 : ((scrollOffset - scrollStartOffset) / (scrollEndOffset - scrollStartOffset) * (targetEndOffset - targetStartOffset)));
      }
      else {
        var scrollPercentage = scrolledPanel.scrollTop / scrolledPanel.scrollHeight;
        var targetOffset = targetPanel.scrollHeight * scrollPercentage;
      }
      return targetOffset;
    }
    //
    function synchronizePanelScroll(event){
      var scrolledPanel = event.currentTarget;
      var currentTime = new Date().getTime();
      if((referencePanel != scrolledPanel) && (currentTime - lastScrollTime > 500)){
        referencePanel = scrolledPanel;
      }
      if(referencePanel == scrolledPanel){
        panels.forEach((panel) => {
          if(panel != scrolledPanel){
            var scrollPosition = getScrollPosition(scrolledPanel, panel, "line");
            panel.scrollTo(0, scrollPosition);
          }
        });
        lastScrollTime = currentTime;
      }
    }
    //
    panels.forEach((panel) => {
      panel.addEventListener("scroll", synchronizePanelScroll);
    });
  
  }
}
</script>

<style lang="scss" scoped>
@import "../styles/components/tidopage.scss";
</style>
